meson: remove static_kwargs
[qemu/kevin.git] / configure
blob8bca8acb2a2163ae780272c02996f350fd61a936
1 #!/bin/sh
3 # qemu configure script (c) 2003 Fabrice Bellard
6 # Unset some variables known to interfere with behavior of common tools,
7 # just as autoconf does.
8 CLICOLOR_FORCE= GREP_OPTIONS=
9 unset CLICOLOR_FORCE GREP_OPTIONS
11 # Don't allow CCACHE, if present, to use cached results of compile tests!
12 export CCACHE_RECACHE=yes
14 # make source path absolute
15 source_path=$(cd "$(dirname -- "$0")"; pwd)
17 if test "$PWD" = "$source_path"
18 then
19 echo "Using './build' as the directory for build output"
21 MARKER=build/auto-created-by-configure
23 if test -e build
24 then
25 if test -f $MARKER
26 then
27 rm -rf build
28 else
29 echo "ERROR: ./build dir already exists and was not previously created by configure"
30 exit 1
34 if ! mkdir build || ! touch $MARKER
35 then
36 echo "ERROR: Could not create ./build directory. Check the permissions on"
37 echo "your source directory, or try doing an out-of-tree build."
38 exit 1
41 cat > GNUmakefile <<'EOF'
42 # This file is auto-generated by configure to support in-source tree
43 # 'make' command invocation
45 ifeq ($(MAKECMDGOALS),)
46 recurse: all
47 endif
49 .NOTPARALLEL: %
50 %: force
51 @echo 'changing dir to build for $(MAKE) "$(MAKECMDGOALS)"...'
52 @$(MAKE) -C build -f Makefile $(MAKECMDGOALS)
53 @if test "$(MAKECMDGOALS)" = "distclean" && \
54 test -e build/auto-created-by-configure ; \
55 then \
56 rm -rf build GNUmakefile ; \
58 force: ;
59 .PHONY: force
60 GNUmakefile: ;
62 EOF
63 cd build
64 exec "$source_path/configure" "$@"
67 # Temporary directory used for files created while
68 # configure runs. Since it is in the build directory
69 # we can safely blow away any previous version of it
70 # (and we need not jump through hoops to try to delete
71 # it when configure exits.)
72 TMPDIR1="config-temp"
73 rm -rf "${TMPDIR1}"
74 if ! mkdir -p "${TMPDIR1}"; then
75 echo "ERROR: failed to create temporary directory"
76 exit 1
79 TMPB="qemu-conf"
80 TMPC="${TMPDIR1}/${TMPB}.c"
81 TMPO="${TMPDIR1}/${TMPB}.o"
82 TMPM="${TMPDIR1}/${TMPB}.m"
83 TMPE="${TMPDIR1}/${TMPB}.exe"
85 rm -f config.log
87 # Print a helpful header at the top of config.log
88 echo "# QEMU configure log $(date)" >> config.log
89 printf "# Configured with:" >> config.log
90 # repeat the invocation to log and stdout for CI
91 invoke=$(printf " '%s'" "$0" "$@")
92 test -n "$GITLAB_CI" && echo "configuring with: $invoke"
93 { echo "$invoke"; echo; echo "#"; } >> config.log
95 quote_sh() {
96 printf "%s" "$1" | sed "s,','\\\\'',g; s,.*,'&',"
99 print_error() {
100 (echo
101 echo "ERROR: $1"
102 while test -n "$2"; do
103 echo " $2"
104 shift
105 done
106 echo) >&2
109 error_exit() {
110 print_error "$@"
111 exit 1
114 do_compiler() {
115 # Run the compiler, capturing its output to the log. First argument
116 # is compiler binary to execute.
117 compiler="$1"
118 shift
119 if test -n "$BASH_VERSION"; then eval '
120 echo >>config.log "
121 funcs: ${FUNCNAME[*]}
122 lines: ${BASH_LINENO[*]}"
123 '; fi
124 echo $compiler "$@" >> config.log
125 $compiler "$@" >> config.log 2>&1 || return $?
128 do_compiler_werror() {
129 # Run the compiler, capturing its output to the log. First argument
130 # is compiler binary to execute.
131 compiler="$1"
132 shift
133 if test -n "$BASH_VERSION"; then eval '
134 echo >>config.log "
135 funcs: ${FUNCNAME[*]}
136 lines: ${BASH_LINENO[*]}"
137 '; fi
138 echo $compiler "$@" >> config.log
139 $compiler "$@" >> config.log 2>&1 || return $?
140 # Test passed. If this is an --enable-werror build, rerun
141 # the test with -Werror and bail out if it fails. This
142 # makes warning-generating-errors in configure test code
143 # obvious to developers.
144 if test "$werror" != "yes"; then
145 return 0
147 # Don't bother rerunning the compile if we were already using -Werror
148 case "$*" in
149 *-Werror*)
150 return 0
152 esac
153 echo $compiler -Werror "$@" >> config.log
154 $compiler -Werror "$@" >> config.log 2>&1 && return $?
155 error_exit "configure test passed without -Werror but failed with -Werror." \
156 "This is probably a bug in the configure script. The failing command" \
157 "will be at the bottom of config.log." \
158 "You can run configure with --disable-werror to bypass this check."
161 do_cc() {
162 do_compiler_werror "$cc" $CPU_CFLAGS "$@"
165 do_objc() {
166 do_compiler_werror "$objcc" $CPU_CFLAGS "$@"
169 # Append $2 to the variable named $1, with space separation
170 add_to() {
171 eval $1=\${$1:+\"\$$1 \"}\$2
174 compile_object() {
175 local_cflags="$1"
176 do_cc $CFLAGS $EXTRA_CFLAGS $CONFIGURE_CFLAGS $QEMU_CFLAGS $local_cflags -c -o $TMPO $TMPC
179 compile_prog() {
180 local_cflags="$1"
181 local_ldflags="$2"
182 do_cc $CFLAGS $EXTRA_CFLAGS $CONFIGURE_CFLAGS $QEMU_CFLAGS $local_cflags -o $TMPE $TMPC \
183 $LDFLAGS $EXTRA_LDFLAGS $CONFIGURE_LDFLAGS $QEMU_LDFLAGS $local_ldflags
186 # symbolically link $1 to $2. Portable version of "ln -sf".
187 symlink() {
188 rm -rf "$2"
189 mkdir -p "$(dirname "$2")"
190 ln -s "$1" "$2"
193 # check whether a command is available to this shell (may be either an
194 # executable or a builtin)
195 has() {
196 type "$1" >/dev/null 2>&1
199 version_ge () {
200 local_ver1=$(expr "$1" : '\([0-9.]*\)' | tr . ' ')
201 local_ver2=$(echo "$2" | tr . ' ')
202 while true; do
203 set x $local_ver1
204 local_first=${2-0}
205 # 'shift 2' if $2 is set, or 'shift' if $2 is not set
206 shift ${2:+2}
207 local_ver1=$*
208 set x $local_ver2
209 # the second argument finished, the first must be greater or equal
210 test $# = 1 && return 0
211 test $local_first -lt $2 && return 1
212 test $local_first -gt $2 && return 0
213 shift ${2:+2}
214 local_ver2=$*
215 done
218 if printf %s\\n "$source_path" "$PWD" | grep -q "[[:space:]:]";
219 then
220 error_exit "main directory cannot contain spaces nor colons"
223 # default parameters
224 cpu=""
225 static="no"
226 cross_compile="no"
227 cross_prefix=""
228 host_cc="cc"
229 stack_protector=""
230 safe_stack=""
231 use_containers="yes"
232 gdb_bin=$(command -v "gdb-multiarch" || command -v "gdb")
233 gdb_arches=""
234 glib_has_gslice="no"
236 if test -e "$source_path/.git"
237 then
238 git_submodules_action="update"
239 else
240 git_submodules_action="ignore"
243 git_submodules="ui/keycodemapdb"
244 git="git"
246 # Don't accept a target_list environment variable.
247 unset target_list
248 unset target_list_exclude
250 # Default value for a variable defining feature "foo".
251 # * foo="no" feature will only be used if --enable-foo arg is given
252 # * foo="" feature will be searched for, and if found, will be used
253 # unless --disable-foo is given
254 # * foo="yes" this value will only be set by --enable-foo flag.
255 # feature will searched for,
256 # if not found, configure exits with error
258 # Always add --enable-foo and --disable-foo command line args.
259 # Distributions want to ensure that several features are compiled in, and it
260 # is impossible without a --enable-foo that exits if a feature is not found.
262 default_feature=""
263 # parse CC options second
264 for opt do
265 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
266 case "$opt" in
267 --without-default-features)
268 default_feature="no"
270 esac
271 done
273 EXTRA_CFLAGS=""
274 EXTRA_CXXFLAGS=""
275 EXTRA_OBJCFLAGS=""
276 EXTRA_LDFLAGS=""
278 debug_tcg="no"
279 sanitizers="no"
280 tsan="no"
281 fortify_source="yes"
282 docs="auto"
283 EXESUF=""
284 modules="no"
285 prefix="/usr/local"
286 qemu_suffix="qemu"
287 softmmu="yes"
288 linux_user=""
289 bsd_user=""
290 pie=""
291 coroutine=""
292 plugins="$default_feature"
293 ninja=""
294 bindir="bin"
295 skip_meson=no
296 vfio_user_server="disabled"
298 # The following Meson options are handled manually (still they
299 # are included in the automatically generated help message)
301 # 1. Track which submodules are needed
302 fdt="auto"
304 # 2. Automatically enable/disable other options
305 tcg="auto"
306 cfi="false"
308 # parse CC options second
309 for opt do
310 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
311 case "$opt" in
312 --cross-prefix=*) cross_prefix="$optarg"
313 cross_compile="yes"
315 --cc=*) CC="$optarg"
317 --cxx=*) CXX="$optarg"
319 --objcc=*) objcc="$optarg"
321 --cpu=*) cpu="$optarg"
323 --extra-cflags=*)
324 EXTRA_CFLAGS="$EXTRA_CFLAGS $optarg"
325 EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
326 EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
328 --extra-cxxflags=*) EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
330 --extra-objcflags=*) EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
332 --extra-ldflags=*) EXTRA_LDFLAGS="$EXTRA_LDFLAGS $optarg"
334 --cross-cc-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-cc-FOO option"
336 --cross-cc-cflags-*) cc_arch=${opt#--cross-cc-cflags-}; cc_arch=${cc_arch%%=*}
337 eval "cross_cc_cflags_${cc_arch}=\$optarg"
339 --cross-cc-*) cc_arch=${opt#--cross-cc-}; cc_arch=${cc_arch%%=*}
340 eval "cross_cc_${cc_arch}=\$optarg"
342 --cross-prefix-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-prefix-FOO option"
344 --cross-prefix-*) cc_arch=${opt#--cross-prefix-}; cc_arch=${cc_arch%%=*}
345 eval "cross_prefix_${cc_arch}=\$optarg"
347 esac
348 done
350 # Preferred compiler:
351 # ${CC} (if set)
352 # ${cross_prefix}gcc (if cross-prefix specified)
353 # system compiler
354 if test -z "${CC}${cross_prefix}"; then
355 cc="$host_cc"
356 else
357 cc="${CC-${cross_prefix}gcc}"
360 if test -z "${CXX}${cross_prefix}"; then
361 cxx="c++"
362 else
363 cxx="${CXX-${cross_prefix}g++}"
366 # Preferred ObjC compiler:
367 # $objcc (if set, i.e. via --objcc option)
368 # ${cross_prefix}clang (if cross-prefix specified)
369 # clang (if available)
370 # $cc
371 if test -z "${objcc}${cross_prefix}"; then
372 if has clang; then
373 objcc=clang
374 else
375 objcc="$cc"
377 else
378 objcc="${objcc-${cross_prefix}clang}"
381 ar="${AR-${cross_prefix}ar}"
382 as="${AS-${cross_prefix}as}"
383 ccas="${CCAS-$cc}"
384 objcopy="${OBJCOPY-${cross_prefix}objcopy}"
385 ld="${LD-${cross_prefix}ld}"
386 ranlib="${RANLIB-${cross_prefix}ranlib}"
387 nm="${NM-${cross_prefix}nm}"
388 smbd="$SMBD"
389 strip="${STRIP-${cross_prefix}strip}"
390 widl="${WIDL-${cross_prefix}widl}"
391 windres="${WINDRES-${cross_prefix}windres}"
392 windmc="${WINDMC-${cross_prefix}windmc}"
393 pkg_config_exe="${PKG_CONFIG-${cross_prefix}pkg-config}"
394 query_pkg_config() {
395 "${pkg_config_exe}" ${QEMU_PKG_CONFIG_FLAGS} "$@"
397 pkg_config=query_pkg_config
398 sdl2_config="${SDL2_CONFIG-${cross_prefix}sdl2-config}"
400 # default flags for all hosts
401 # We use -fwrapv to tell the compiler that we require a C dialect where
402 # left shift of signed integers is well defined and has the expected
403 # 2s-complement style results. (Both clang and gcc agree that it
404 # provides these semantics.)
405 QEMU_CFLAGS="-fno-strict-aliasing -fno-common -fwrapv"
406 QEMU_CFLAGS="-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE $QEMU_CFLAGS"
408 QEMU_LDFLAGS=
410 # Flags that are needed during configure but later taken care of by Meson
411 CONFIGURE_CFLAGS="-std=gnu11 -Wall"
412 CONFIGURE_LDFLAGS=
415 check_define() {
416 cat > $TMPC <<EOF
417 #if !defined($1)
418 #error $1 not defined
419 #endif
420 int main(void) { return 0; }
422 compile_object
425 check_include() {
426 cat > $TMPC <<EOF
427 #include <$1>
428 int main(void) { return 0; }
430 compile_object
433 write_c_skeleton() {
434 cat > $TMPC <<EOF
435 int main(void) { return 0; }
439 if check_define __linux__ ; then
440 targetos=linux
441 elif check_define _WIN32 ; then
442 targetos=windows
443 elif check_define __OpenBSD__ ; then
444 targetos=openbsd
445 elif check_define __sun__ ; then
446 targetos=sunos
447 elif check_define __HAIKU__ ; then
448 targetos=haiku
449 elif check_define __FreeBSD__ ; then
450 targetos=freebsd
451 elif check_define __FreeBSD_kernel__ && check_define __GLIBC__; then
452 targetos=gnu/kfreebsd
453 elif check_define __DragonFly__ ; then
454 targetos=dragonfly
455 elif check_define __NetBSD__; then
456 targetos=netbsd
457 elif check_define __APPLE__; then
458 targetos=darwin
459 else
460 # This is a fatal error, but don't report it yet, because we
461 # might be going to just print the --help text, or it might
462 # be the result of a missing compiler.
463 targetos=bogus
466 # OS specific
468 mingw32="no"
469 bsd="no"
470 linux="no"
471 solaris="no"
472 case $targetos in
473 windows)
474 mingw32="yes"
475 plugins="no"
476 pie="no"
478 gnu/kfreebsd)
479 bsd="yes"
481 freebsd)
482 bsd="yes"
483 make="${MAKE-gmake}"
484 # needed for kinfo_getvmmap(3) in libutil.h
486 dragonfly)
487 bsd="yes"
488 make="${MAKE-gmake}"
490 netbsd)
491 bsd="yes"
492 make="${MAKE-gmake}"
494 openbsd)
495 bsd="yes"
496 make="${MAKE-gmake}"
498 darwin)
499 bsd="yes"
500 darwin="yes"
501 # Disable attempts to use ObjectiveC features in os/object.h since they
502 # won't work when we're compiling with gcc as a C compiler.
503 QEMU_CFLAGS="-DOS_OBJECT_USE_OBJC=0 $QEMU_CFLAGS"
505 sunos)
506 solaris="yes"
507 make="${MAKE-gmake}"
508 # needed for CMSG_ macros in sys/socket.h
509 QEMU_CFLAGS="-D_XOPEN_SOURCE=600 $QEMU_CFLAGS"
510 # needed for TIOCWIN* defines in termios.h
511 QEMU_CFLAGS="-D__EXTENSIONS__ $QEMU_CFLAGS"
513 haiku)
514 pie="no"
515 QEMU_CFLAGS="-DB_USE_POSITIVE_POSIX_ERRORS -D_BSD_SOURCE -fPIC $QEMU_CFLAGS"
517 linux)
518 linux="yes"
520 esac
522 if test ! -z "$cpu" ; then
523 # command line argument
525 elif check_define __i386__ ; then
526 cpu="i386"
527 elif check_define __x86_64__ ; then
528 if check_define __ILP32__ ; then
529 cpu="x32"
530 else
531 cpu="x86_64"
533 elif check_define __sparc__ ; then
534 if check_define __arch64__ ; then
535 cpu="sparc64"
536 else
537 cpu="sparc"
539 elif check_define _ARCH_PPC ; then
540 if check_define _ARCH_PPC64 ; then
541 if check_define _LITTLE_ENDIAN ; then
542 cpu="ppc64le"
543 else
544 cpu="ppc64"
546 else
547 cpu="ppc"
549 elif check_define __mips__ ; then
550 cpu="mips"
551 elif check_define __s390__ ; then
552 if check_define __s390x__ ; then
553 cpu="s390x"
554 else
555 cpu="s390"
557 elif check_define __riscv ; then
558 cpu="riscv"
559 elif check_define __arm__ ; then
560 cpu="arm"
561 elif check_define __aarch64__ ; then
562 cpu="aarch64"
563 elif check_define __loongarch64 ; then
564 cpu="loongarch64"
565 else
566 # Using uname is really broken, but it is just a fallback for architectures
567 # that are going to use TCI anyway
568 cpu=$(uname -m)
569 echo "WARNING: unrecognized host CPU, proceeding with 'uname -m' output '$cpu'"
572 # Normalise host CPU name and set multilib cflags. The canonicalization
573 # isn't really necessary, because the architectures that we check for
574 # should not hit the 'uname -m' case, but better safe than sorry.
575 # Note that this case should only have supported host CPUs, not guests.
576 case "$cpu" in
577 armv*b|armv*l|arm)
578 cpu="arm" ;;
580 i386|i486|i586|i686)
581 cpu="i386"
582 CPU_CFLAGS="-m32" ;;
583 x32)
584 cpu="x86_64"
585 CPU_CFLAGS="-mx32" ;;
586 x86_64|amd64)
587 cpu="x86_64"
588 # ??? Only extremely old AMD cpus do not have cmpxchg16b.
589 # If we truly care, we should simply detect this case at
590 # runtime and generate the fallback to serial emulation.
591 CPU_CFLAGS="-m64 -mcx16" ;;
593 mips*)
594 cpu="mips" ;;
596 ppc)
597 CPU_CFLAGS="-m32" ;;
598 ppc64)
599 CPU_CFLAGS="-m64 -mbig-endian" ;;
600 ppc64le)
601 cpu="ppc64"
602 CPU_CFLAGS="-m64 -mlittle-endian" ;;
604 s390)
605 CPU_CFLAGS="-m31" ;;
606 s390x)
607 CPU_CFLAGS="-m64" ;;
609 sparc|sun4[cdmuv])
610 cpu="sparc"
611 CPU_CFLAGS="-m32 -mv8plus -mcpu=ultrasparc" ;;
612 sparc64)
613 CPU_CFLAGS="-m64 -mcpu=ultrasparc" ;;
614 esac
616 : ${make=${MAKE-make}}
619 check_py_version() {
620 # We require python >= 3.7.
621 # NB: a True python conditional creates a non-zero return code (Failure)
622 "$1" -c 'import sys; sys.exit(sys.version_info < (3,7))'
625 python=
626 pypi="enabled"
627 first_python=
628 if test -z "${PYTHON}"; then
629 # A bare 'python' is traditionally python 2.x, but some distros
630 # have it as python 3.x, so check in both places.
631 for binary in python3 python python3.11 python3.10 python3.9 python3.8 python3.7; do
632 if has "$binary"; then
633 python=$(command -v "$binary")
634 if check_py_version "$python"; then
635 # This one is good.
636 first_python=
637 break
638 else
639 first_python=$python
642 done
643 else
644 # Same as above, but only check the environment variable.
645 has "${PYTHON}" || error_exit "The PYTHON environment variable does not point to an executable"
646 python=$(command -v "$PYTHON")
647 if check_py_version "$python"; then
648 # This one is good.
649 first_python=
650 else
651 first_python=$first_python
655 # Check for ancillary tools used in testing
656 genisoimage=
657 for binary in genisoimage mkisofs
659 if has $binary
660 then
661 genisoimage=$(command -v "$binary")
662 break
664 done
666 if test "$mingw32" = "yes" ; then
667 EXESUF=".exe"
668 # MinGW needs -mthreads for TLS and macro _MT.
669 CONFIGURE_CFLAGS="-mthreads $CONFIGURE_CFLAGS"
670 prefix="/qemu"
671 bindir=""
672 qemu_suffix=""
675 werror=""
677 meson_option_build_array() {
678 printf '['
679 (if test "$targetos" = windows; then
680 IFS=\;
681 else
682 IFS=:
684 for e in $1; do
685 printf '"""'
686 # backslash escape any '\' and '"' characters
687 printf "%s" "$e" | sed -e 's/\([\"]\)/\\\1/g'
688 printf '""",'
689 done)
690 printf ']\n'
693 . "$source_path/scripts/meson-buildoptions.sh"
695 meson_options=
696 meson_option_add() {
697 meson_options="$meson_options $(quote_sh "$1")"
699 meson_option_parse() {
700 meson_options="$meson_options $(_meson_option_parse "$@")"
701 if test $? -eq 1; then
702 echo "ERROR: unknown option $1"
703 echo "Try '$0 --help' for more information"
704 exit 1
708 for opt do
709 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
710 case "$opt" in
711 --help|-h) show_help=yes
713 --version|-V) exec cat "$source_path/VERSION"
715 --prefix=*) prefix="$optarg"
717 --cross-prefix=*)
719 --cc=*)
721 --host-cc=*) host_cc="$optarg"
723 --cxx=*)
725 --objcc=*)
727 --make=*) make="$optarg"
729 --install=*)
731 --python=*) python="$optarg"
733 --skip-meson) skip_meson=yes
735 --ninja=*) ninja="$optarg"
737 --smbd=*) smbd="$optarg"
739 --extra-cflags=*)
741 --extra-cxxflags=*)
743 --extra-objcflags=*)
745 --extra-ldflags=*)
747 --cross-cc-*)
749 --cross-prefix-*)
751 --enable-debug-info) meson_option_add -Ddebug=true
753 --disable-debug-info) meson_option_add -Ddebug=false
755 --enable-docs) docs=enabled
757 --disable-docs) docs=disabled
759 --enable-modules)
760 modules="yes"
762 --disable-modules)
763 modules="no"
765 --cpu=*)
767 --target-list=*) target_list="$optarg"
768 if test "$target_list_exclude"; then
769 error_exit "Can't mix --target-list with --target-list-exclude"
772 --target-list-exclude=*) target_list_exclude="$optarg"
773 if test "$target_list"; then
774 error_exit "Can't mix --target-list-exclude with --target-list"
777 --with-default-devices) meson_option_add -Ddefault_devices=true
779 --without-default-devices) meson_option_add -Ddefault_devices=false
781 --with-devices-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --with-devices-FOO option"
783 --with-devices-*) device_arch=${opt#--with-devices-};
784 device_arch=${device_arch%%=*}
785 cf=$source_path/configs/devices/$device_arch-softmmu/$optarg.mak
786 if test -f "$cf"; then
787 device_archs="$device_archs $device_arch"
788 eval "devices_${device_arch}=\$optarg"
789 else
790 error_exit "File $cf does not exist"
793 --without-default-features) # processed above
795 --static)
796 static="yes"
797 QEMU_PKG_CONFIG_FLAGS="--static $QEMU_PKG_CONFIG_FLAGS"
799 --bindir=*) bindir="$optarg"
801 --with-suffix=*) qemu_suffix="$optarg"
803 --host=*|--build=*|\
804 --disable-dependency-tracking|\
805 --sbindir=*|--sharedstatedir=*|\
806 --oldincludedir=*|--datarootdir=*|--infodir=*|\
807 --htmldir=*|--dvidir=*|--pdfdir=*|--psdir=*)
808 # These switches are silently ignored, for compatibility with
809 # autoconf-generated configure scripts. This allows QEMU's
810 # configure to be used by RPM and similar macros that set
811 # lots of directory switches by default.
813 --enable-debug-tcg) debug_tcg="yes"
815 --disable-debug-tcg) debug_tcg="no"
817 --enable-debug)
818 # Enable debugging options that aren't excessively noisy
819 debug_tcg="yes"
820 meson_option_parse --enable-debug-graph-lock ""
821 meson_option_parse --enable-debug-mutex ""
822 meson_option_add -Doptimization=0
823 fortify_source="no"
825 --enable-sanitizers) sanitizers="yes"
827 --disable-sanitizers) sanitizers="no"
829 --enable-tsan) tsan="yes"
831 --disable-tsan) tsan="no"
833 --disable-tcg) tcg="disabled"
834 plugins="no"
836 --enable-tcg) tcg="enabled"
838 --disable-system) softmmu="no"
840 --enable-system) softmmu="yes"
842 --disable-user)
843 linux_user="no" ;
844 bsd_user="no" ;
846 --enable-user) ;;
847 --disable-linux-user) linux_user="no"
849 --enable-linux-user) linux_user="yes"
851 --disable-bsd-user) bsd_user="no"
853 --enable-bsd-user) bsd_user="yes"
855 --enable-pie) pie="yes"
857 --disable-pie) pie="no"
859 --enable-werror) werror="yes"
861 --disable-werror) werror="no"
863 --enable-stack-protector) stack_protector="yes"
865 --disable-stack-protector) stack_protector="no"
867 --enable-safe-stack) safe_stack="yes"
869 --disable-safe-stack) safe_stack="no"
871 --enable-cfi)
872 cfi="true";
873 meson_option_add -Db_lto=true
875 --disable-cfi) cfi="false"
877 --disable-fdt) fdt="disabled"
879 --enable-fdt) fdt="enabled"
881 --enable-fdt=git) fdt="internal"
883 --enable-fdt=*) fdt="$optarg"
885 --with-coroutine=*) coroutine="$optarg"
887 --with-git=*) git="$optarg"
889 --with-git-submodules=*)
890 git_submodules_action="$optarg"
892 --disable-pypi) pypi="disabled"
894 --enable-pypi) pypi="enabled"
896 --enable-plugins) if test "$mingw32" = "yes"; then
897 error_exit "TCG plugins not currently supported on Windows platforms"
898 else
899 plugins="yes"
902 --disable-plugins) plugins="no"
904 --enable-containers) use_containers="yes"
906 --disable-containers) use_containers="no"
908 --gdb=*) gdb_bin="$optarg"
910 --enable-vfio-user-server) vfio_user_server="enabled"
912 --disable-vfio-user-server) vfio_user_server="disabled"
914 # everything else has the same name in configure and meson
915 --*) meson_option_parse "$opt" "$optarg"
917 esac
918 done
920 # test for any invalid configuration combinations
921 if test "$plugins" = "yes" -a "$tcg" = "disabled"; then
922 error_exit "Can't enable plugins on non-TCG builds"
925 case $git_submodules_action in
926 update|validate)
927 if test ! -e "$source_path/.git"; then
928 echo "ERROR: cannot $git_submodules_action git submodules without .git"
929 exit 1
932 ignore)
933 if ! test -f "$source_path/ui/keycodemapdb/README"
934 then
935 echo
936 echo "ERROR: missing GIT submodules"
937 echo
938 if test -e "$source_path/.git"; then
939 echo "--with-git-submodules=ignore specified but submodules were not"
940 echo "checked out. Please initialize and update submodules."
941 else
942 echo "This is not a GIT checkout but module content appears to"
943 echo "be missing. Do not use 'git archive' or GitHub download links"
944 echo "to acquire QEMU source archives. Non-GIT builds are only"
945 echo "supported with source archives linked from:"
946 echo
947 echo " https://www.qemu.org/download/#source"
948 echo
949 echo "Developers working with GIT can use scripts/archive-source.sh"
950 echo "if they need to create valid source archives."
952 echo
953 exit 1
957 echo "ERROR: invalid --with-git-submodules= value '$git_submodules_action'"
958 exit 1
960 esac
962 default_target_list=""
963 mak_wilds=""
965 if [ "$linux_user" != no ]; then
966 if [ "$targetos" = linux ] && [ -d "$source_path/linux-user/include/host/$cpu" ]; then
967 linux_user=yes
968 elif [ "$linux_user" = yes ]; then
969 error_exit "linux-user not supported on this architecture"
972 if [ "$bsd_user" != no ]; then
973 if [ "$bsd_user" = "" ]; then
974 test $targetos = freebsd && bsd_user=yes
976 if [ "$bsd_user" = yes ] && ! [ -d "$source_path/bsd-user/$targetos" ]; then
977 error_exit "bsd-user not supported on this host OS"
980 if [ "$softmmu" = "yes" ]; then
981 mak_wilds="${mak_wilds} $source_path/configs/targets/*-softmmu.mak"
983 if [ "$linux_user" = "yes" ]; then
984 mak_wilds="${mak_wilds} $source_path/configs/targets/*-linux-user.mak"
986 if [ "$bsd_user" = "yes" ]; then
987 mak_wilds="${mak_wilds} $source_path/configs/targets/*-bsd-user.mak"
990 for config in $mak_wilds; do
991 target="$(basename "$config" .mak)"
992 if echo "$target_list_exclude" | grep -vq "$target"; then
993 default_target_list="${default_target_list} $target"
995 done
997 if test x"$show_help" = x"yes" ; then
998 cat << EOF
1000 Usage: configure [options]
1001 Options: [defaults in brackets after descriptions]
1003 Standard options:
1004 --help print this message
1005 --prefix=PREFIX install in PREFIX [$prefix]
1006 --target-list=LIST set target list (default: build all)
1007 $(echo Available targets: $default_target_list | \
1008 fold -s -w 53 | sed -e 's/^/ /')
1009 --target-list-exclude=LIST exclude a set of targets from the default target-list
1011 Advanced options (experts only):
1012 --cross-prefix=PREFIX use PREFIX for compile tools, PREFIX can be blank [$cross_prefix]
1013 --cc=CC use C compiler CC [$cc]
1014 --host-cc=CC use C compiler CC [$host_cc] for code run at
1015 build time
1016 --cxx=CXX use C++ compiler CXX [$cxx]
1017 --objcc=OBJCC use Objective-C compiler OBJCC [$objcc]
1018 --extra-cflags=CFLAGS append extra C compiler flags CFLAGS
1019 --extra-cxxflags=CXXFLAGS append extra C++ compiler flags CXXFLAGS
1020 --extra-objcflags=OBJCFLAGS append extra Objective C compiler flags OBJCFLAGS
1021 --extra-ldflags=LDFLAGS append extra linker flags LDFLAGS
1022 --cross-cc-ARCH=CC use compiler when building ARCH guest test cases
1023 --cross-cc-cflags-ARCH= use compiler flags when building ARCH guest tests
1024 --cross-prefix-ARCH=PREFIX cross compiler prefix when building ARCH guest test cases
1025 --make=MAKE use specified make [$make]
1026 --python=PYTHON use specified python [$python]
1027 --ninja=NINJA use specified ninja [$ninja]
1028 --smbd=SMBD use specified smbd [$smbd]
1029 --with-git=GIT use specified git [$git]
1030 --with-git-submodules=update update git submodules (default if .git dir exists)
1031 --with-git-submodules=validate fail if git submodules are not up to date
1032 --with-git-submodules=ignore do not update or check git submodules (default if no .git dir)
1033 --static enable static build [$static]
1034 --bindir=PATH install binaries in PATH
1035 --with-suffix=SUFFIX suffix for QEMU data inside datadir/libdir/sysconfdir/docdir [$qemu_suffix]
1036 --without-default-features default all --enable-* options to "disabled"
1037 --without-default-devices do not include any device that is not needed to
1038 start the emulator (only use if you are including
1039 desired devices in configs/devices/)
1040 --with-devices-ARCH=NAME override default configs/devices
1041 --enable-debug enable common debug build options
1042 --enable-sanitizers enable default sanitizers
1043 --enable-tsan enable thread sanitizer
1044 --disable-werror disable compilation abort on warning
1045 --disable-stack-protector disable compiler-provided stack protection
1046 --cpu=CPU Build for host CPU [$cpu]
1047 --with-coroutine=BACKEND coroutine backend. Supported options:
1048 ucontext, sigaltstack, windows
1049 --enable-plugins
1050 enable plugins via shared library loading
1051 --disable-containers don't use containers for cross-building
1052 --gdb=GDB-path gdb to use for gdbstub tests [$gdb_bin]
1054 meson_options_help
1055 cat << EOF
1056 system all system emulation targets
1057 user supported user emulation targets
1058 linux-user all linux usermode emulation targets
1059 bsd-user all BSD usermode emulation targets
1060 pie Position Independent Executables
1061 modules modules support (non-Windows)
1062 debug-tcg TCG debugging (default is disabled)
1063 debug-info debugging information
1064 safe-stack SafeStack Stack Smash Protection. Depends on
1065 clang/llvm and requires coroutine backend ucontext.
1067 NOTE: The object files are built at the place where configure is launched
1069 exit 0
1072 # Remove old dependency files to make sure that they get properly regenerated
1073 rm -f ./*/config-devices.mak.d
1075 if test -z "$python"
1076 then
1077 # If first_python is set, there was a binary somewhere even though
1078 # it was not suitable. Use it for the error message.
1079 if test -n "$first_python"; then
1080 error_exit "Cannot use '$first_python', Python >= 3.7 is required." \
1081 "Use --python=/path/to/python to specify a supported Python."
1082 else
1083 error_exit "Python not found. Use --python=/path/to/python"
1087 if ! has "$make"
1088 then
1089 error_exit "GNU make ($make) not found"
1092 if ! check_py_version "$python"; then
1093 error_exit "Cannot use '$python', Python >= 3.7 is required." \
1094 "Use --python=/path/to/python to specify a supported Python." \
1095 "Maybe try:" \
1096 " openSUSE Leap 15.3+: zypper install python39" \
1097 " CentOS 8: dnf install python38"
1100 # Resolve PATH
1101 python="$(command -v "$python")"
1103 # Create a Python virtual environment using our configured python.
1104 # The stdout of this script will be the location of a symlink that
1105 # points to the configured Python.
1106 # Entry point scripts for pip, meson, and sphinx are generated if those
1107 # packages are present.
1109 # Defaults assumed for now:
1110 # - venv is cleared if it exists already;
1111 # - venv is allowed to use system packages;
1112 # - all setup can be performed offline;
1113 # - missing packages may be fetched from PyPI,
1114 # unless --disable-pypi is passed.
1115 # - pip is not installed into the venv when possible,
1116 # but ensurepip is called as a fallback when necessary.
1118 echo "python determined to be '$python'"
1119 echo "python version: $($python --version)"
1121 python="$($python -B "${source_path}/python/scripts/mkvenv.py" create pyvenv)"
1122 if test "$?" -ne 0 ; then
1123 error_exit "python venv creation failed"
1126 # Suppress writing compiled files
1127 python="$python -B"
1128 mkvenv="$python ${source_path}/python/scripts/mkvenv.py"
1130 mkvenv_flags=""
1131 if test "$pypi" = "enabled" ; then
1132 mkvenv_flags="--online"
1135 if ! $mkvenv ensure \
1136 $mkvenv_flags \
1137 --dir "${source_path}/python/wheels" \
1138 --diagnose "meson" \
1139 "meson>=0.63.0" ;
1140 then
1141 exit 1
1144 # At this point, we expect Meson to be installed and available.
1145 # We expect mkvenv or pip to have created pyvenv/bin/meson for us.
1146 # We ignore PATH completely here: we want to use the venv's Meson
1147 # *exclusively*.
1149 meson="$(cd pyvenv/bin; pwd)/meson"
1151 # Conditionally ensure Sphinx is installed.
1153 mkvenv_flags=""
1154 if test "$pypi" = "enabled" -a "$docs" = "enabled" ; then
1155 mkvenv_flags="--online"
1158 if test "$docs" != "disabled" ; then
1159 if ! $mkvenv ensure \
1160 $mkvenv_flags \
1161 --diagnose "sphinx-build" \
1162 "sphinx>=1.6.0" "sphinx-rtd-theme>=0.5.0";
1163 then
1164 if test "$docs" = "enabled" ; then
1165 exit 1
1167 echo "Sphinx not found/usable, disabling docs."
1168 docs=disabled
1169 else
1170 docs=enabled
1174 # Probe for ninja
1176 if test -z "$ninja"; then
1177 for c in ninja ninja-build samu; do
1178 if has $c; then
1179 ninja=$(command -v "$c")
1180 break
1182 done
1183 if test -z "$ninja"; then
1184 error_exit "Cannot find Ninja"
1188 # Check that the C compiler works. Doing this here before testing
1189 # the host CPU ensures that we had a valid CC to autodetect the
1190 # $cpu var (and we should bail right here if that's not the case).
1191 # It also allows the help message to be printed without a CC.
1192 write_c_skeleton;
1193 if compile_object ; then
1194 : C compiler works ok
1195 else
1196 error_exit "\"$cc\" either does not exist or does not work"
1198 if ! compile_prog ; then
1199 error_exit "\"$cc\" cannot build an executable (is your linker broken?)"
1202 # Consult white-list to determine whether to enable werror
1203 # by default. Only enable by default for git builds
1204 if test -z "$werror" ; then
1205 if test "$git_submodules_action" != "ignore" && \
1206 { test "$linux" = "yes" || test "$mingw32" = "yes"; }; then
1207 werror="yes"
1208 else
1209 werror="no"
1213 if test "$targetos" = "bogus"; then
1214 # Now that we know that we're not printing the help and that
1215 # the compiler works (so the results of the check_defines we used
1216 # to identify the OS are reliable), if we didn't recognize the
1217 # host OS we should stop now.
1218 error_exit "Unrecognized host OS (uname -s reports '$(uname -s)')"
1221 # Check whether the compiler matches our minimum requirements:
1222 cat > $TMPC << EOF
1223 #if defined(__clang_major__) && defined(__clang_minor__)
1224 # ifdef __apple_build_version__
1225 # if __clang_major__ < 12 || (__clang_major__ == 12 && __clang_minor__ < 0)
1226 # error You need at least XCode Clang v12.0 to compile QEMU
1227 # endif
1228 # else
1229 # if __clang_major__ < 10 || (__clang_major__ == 10 && __clang_minor__ < 0)
1230 # error You need at least Clang v10.0 to compile QEMU
1231 # endif
1232 # endif
1233 #elif defined(__GNUC__) && defined(__GNUC_MINOR__)
1234 # if __GNUC__ < 7 || (__GNUC__ == 7 && __GNUC_MINOR__ < 4)
1235 # error You need at least GCC v7.4.0 to compile QEMU
1236 # endif
1237 #else
1238 # error You either need GCC or Clang to compiler QEMU
1239 #endif
1240 int main (void) { return 0; }
1242 if ! compile_prog "" "" ; then
1243 error_exit "You need at least GCC v7.4 or Clang v10.0 (or XCode Clang v12.0)"
1246 # Accumulate -Wfoo and -Wno-bar separately.
1247 # We will list all of the enable flags first, and the disable flags second.
1248 # Note that we do not add -Werror, because that would enable it for all
1249 # configure tests. If a configure test failed due to -Werror this would
1250 # just silently disable some features, so it's too error prone.
1252 warn_flags=
1253 add_to warn_flags -Wundef
1254 add_to warn_flags -Wwrite-strings
1255 add_to warn_flags -Wmissing-prototypes
1256 add_to warn_flags -Wstrict-prototypes
1257 add_to warn_flags -Wredundant-decls
1258 add_to warn_flags -Wold-style-declaration
1259 add_to warn_flags -Wold-style-definition
1260 add_to warn_flags -Wtype-limits
1261 add_to warn_flags -Wformat-security
1262 add_to warn_flags -Wformat-y2k
1263 add_to warn_flags -Winit-self
1264 add_to warn_flags -Wignored-qualifiers
1265 add_to warn_flags -Wempty-body
1266 add_to warn_flags -Wnested-externs
1267 add_to warn_flags -Wendif-labels
1268 add_to warn_flags -Wexpansion-to-defined
1269 add_to warn_flags -Wimplicit-fallthrough=2
1270 add_to warn_flags -Wmissing-format-attribute
1272 if test "$targetos" != "darwin"; then
1273 add_to warn_flags -Wthread-safety
1276 nowarn_flags=
1277 add_to nowarn_flags -Wno-initializer-overrides
1278 add_to nowarn_flags -Wno-missing-include-dirs
1279 add_to nowarn_flags -Wno-shift-negative-value
1280 add_to nowarn_flags -Wno-string-plus-int
1281 add_to nowarn_flags -Wno-typedef-redefinition
1282 add_to nowarn_flags -Wno-tautological-type-limit-compare
1283 add_to nowarn_flags -Wno-psabi
1284 add_to nowarn_flags -Wno-gnu-variable-sized-type-not-at-end
1286 gcc_flags="$warn_flags $nowarn_flags"
1288 cc_has_warning_flag() {
1289 write_c_skeleton;
1291 # Use the positive sense of the flag when testing for -Wno-wombat
1292 # support (gcc will happily accept the -Wno- form of unknown
1293 # warning options).
1294 optflag="$(echo $1 | sed -e 's/^-Wno-/-W/')"
1295 compile_prog "-Werror $optflag" ""
1298 objcc_has_warning_flag() {
1299 cat > $TMPM <<EOF
1300 int main(void) { return 0; }
1303 # Use the positive sense of the flag when testing for -Wno-wombat
1304 # support (gcc will happily accept the -Wno- form of unknown
1305 # warning options).
1306 optflag="$(echo $1 | sed -e 's/^-Wno-/-W/')"
1307 do_objc -Werror $optflag \
1308 $OBJCFLAGS $EXTRA_OBJCFLAGS $CONFIGURE_OBJCFLAGS $QEMU_OBJCFLAGS \
1309 -o $TMPE $TMPM $QEMU_LDFLAGS
1312 for flag in $gcc_flags; do
1313 if cc_has_warning_flag $flag ; then
1314 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1316 if objcc_has_warning_flag $flag ; then
1317 QEMU_OBJCFLAGS="$QEMU_OBJCFLAGS $flag"
1319 done
1321 if test "$stack_protector" != "no"; then
1322 cat > $TMPC << EOF
1323 int main(int argc, char *argv[])
1325 char arr[64], *p = arr, *c = argv[argc - 1];
1326 while (*c) {
1327 *p++ = *c++;
1329 return 0;
1332 gcc_flags="-fstack-protector-strong -fstack-protector-all"
1333 sp_on=0
1334 for flag in $gcc_flags; do
1335 # We need to check both a compile and a link, since some compiler
1336 # setups fail only on a .c->.o compile and some only at link time
1337 if compile_object "-Werror $flag" &&
1338 compile_prog "-Werror $flag" ""; then
1339 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1340 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1341 sp_on=1
1342 break
1344 done
1345 if test "$stack_protector" = yes; then
1346 if test $sp_on = 0; then
1347 error_exit "Stack protector not supported"
1352 # Our module code doesn't support Windows
1353 if test "$modules" = "yes" && test "$mingw32" = "yes" ; then
1354 error_exit "Modules are not available for Windows"
1357 # Static linking is not possible with plugins, modules or PIE
1358 if test "$static" = "yes" ; then
1359 if test "$modules" = "yes" ; then
1360 error_exit "static and modules are mutually incompatible"
1362 if test "$plugins" = "yes"; then
1363 error_exit "static and plugins are mutually incompatible"
1364 else
1365 plugins="no"
1368 test "$plugins" = "" && plugins=yes
1370 cat > $TMPC << EOF
1372 #ifdef __linux__
1373 # define THREAD __thread
1374 #else
1375 # define THREAD
1376 #endif
1377 static THREAD int tls_var;
1378 int main(void) { return tls_var; }
1381 # Meson currently only handles pie as a boolean for now so if we have
1382 # explicitly disabled PIE we need to extend our cflags because it wont.
1383 if test "$static" = "yes"; then
1384 if test "$pie" != "no" && compile_prog "-Werror -fPIE -DPIE" "-static-pie"; then
1385 CONFIGURE_CFLAGS="-fPIE -DPIE $CONFIGURE_CFLAGS"
1386 pie="yes"
1387 elif test "$pie" = "yes"; then
1388 error_exit "-static-pie not available due to missing toolchain support"
1389 else
1390 pie="no"
1391 QEMU_CFLAGS="-fno-pie $QEMU_CFLAGS"
1393 elif test "$pie" = "no"; then
1394 if compile_prog "-Werror -fno-pie" "-no-pie"; then
1395 CONFIGURE_CFLAGS="-fno-pie $CONFIGURE_CFLAGS"
1396 CONFIGURE_LDFLAGS="-no-pie $CONFIGURE_LDFLAGS"
1397 QEMU_CFLAGS="-fno-pie -no-pie $QEMU_CFLAGS"
1399 elif compile_prog "-Werror -fPIE -DPIE" "-pie"; then
1400 CONFIGURE_CFLAGS="-fPIE -DPIE $CONFIGURE_CFLAGS"
1401 CONFIGURE_LDFLAGS="-pie $CONFIGURE_LDFLAGS"
1402 pie="yes"
1403 elif test "$pie" = "yes"; then
1404 error_exit "PIE not available due to missing toolchain support"
1405 else
1406 echo "Disabling PIE due to missing toolchain support"
1407 pie="no"
1410 ##########################################
1411 # __sync_fetch_and_and requires at least -march=i486. Many toolchains
1412 # use i686 as default anyway, but for those that don't, an explicit
1413 # specification is necessary
1415 if test "$cpu" = "i386"; then
1416 cat > $TMPC << EOF
1417 static int sfaa(int *ptr)
1419 return __sync_fetch_and_and(ptr, 0);
1422 int main(void)
1424 int val = 42;
1425 val = __sync_val_compare_and_swap(&val, 0, 1);
1426 sfaa(&val);
1427 return val;
1430 if ! compile_prog "" "" ; then
1431 QEMU_CFLAGS="-march=i486 $QEMU_CFLAGS"
1435 if test -z "${target_list+xxx}" ; then
1436 default_targets=yes
1437 for target in $default_target_list; do
1438 target_list="$target_list $target"
1439 done
1440 target_list="${target_list# }"
1441 else
1442 default_targets=no
1443 target_list=$(echo "$target_list" | sed -e 's/,/ /g')
1444 for target in $target_list; do
1445 # Check that we recognised the target name; this allows a more
1446 # friendly error message than if we let it fall through.
1447 case " $default_target_list " in
1448 *" $target "*)
1451 error_exit "Unknown target name '$target'"
1453 esac
1454 done
1457 # see if system emulation was really requested
1458 case " $target_list " in
1459 *"-softmmu "*) softmmu=yes
1461 *) softmmu=no
1463 esac
1465 if test "$tcg" = "auto"; then
1466 if test -z "$target_list"; then
1467 tcg="disabled"
1468 else
1469 tcg="enabled"
1473 if test "$tcg" = "enabled"; then
1474 git_submodules="$git_submodules tests/fp/berkeley-testfloat-3"
1475 git_submodules="$git_submodules tests/fp/berkeley-softfloat-3"
1478 ##########################################
1479 # big/little endian test
1480 cat > $TMPC << EOF
1481 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
1482 # error LITTLE
1483 #endif
1484 int main(void) { return 0; }
1487 if ! compile_prog ; then
1488 bigendian="no"
1489 else
1490 cat > $TMPC << EOF
1491 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
1492 # error BIG
1493 #endif
1494 int main(void) { return 0; }
1497 if ! compile_prog ; then
1498 bigendian="yes"
1499 else
1500 echo big/little test failed
1501 exit 1
1505 ##########################################
1506 # pkg-config probe
1508 if ! has "$pkg_config_exe"; then
1509 error_exit "pkg-config binary '$pkg_config_exe' not found"
1512 ##########################################
1513 # glib support probe
1515 # When bumping glib_req_ver, please check also whether we should increase
1516 # the _WIN32_WINNT setting in osdep.h according to the value from glib
1517 glib_req_ver=2.56
1518 glib_modules=gthread-2.0
1519 if test "$modules" = yes; then
1520 glib_modules="$glib_modules gmodule-export-2.0"
1521 elif test "$plugins" = "yes"; then
1522 glib_modules="$glib_modules gmodule-no-export-2.0"
1525 for i in $glib_modules; do
1526 if $pkg_config --atleast-version=$glib_req_ver $i; then
1527 glib_cflags=$($pkg_config --cflags $i)
1528 glib_libs=$($pkg_config --libs $i)
1529 else
1530 error_exit "glib-$glib_req_ver $i is required to compile QEMU"
1532 done
1534 # Check whether glib has gslice, which we have to avoid for correctness.
1535 # TODO: remove this check and the corresponding workaround (qtree) when
1536 # the minimum supported glib is >= $glib_dropped_gslice_version.
1537 glib_dropped_gslice_version=2.75.3
1538 for i in $glib_modules; do
1539 if ! $pkg_config --atleast-version=$glib_dropped_gslice_version $i; then
1540 glib_has_gslice="yes"
1541 break
1543 done
1545 glib_bindir="$($pkg_config --variable=bindir glib-2.0)"
1546 if test -z "$glib_bindir" ; then
1547 glib_bindir="$($pkg_config --variable=prefix glib-2.0)"/bin
1550 # This workaround is required due to a bug in pkg-config file for glib as it
1551 # doesn't define GLIB_STATIC_COMPILATION for pkg-config --static
1553 if test "$static" = yes && test "$mingw32" = yes; then
1554 glib_cflags="-DGLIB_STATIC_COMPILATION $glib_cflags"
1557 # Sanity check that the current size_t matches the
1558 # size that glib thinks it should be. This catches
1559 # problems on multi-arch where people try to build
1560 # 32-bit QEMU while pointing at 64-bit glib headers
1561 cat > $TMPC <<EOF
1562 #include <glib.h>
1563 #include <unistd.h>
1565 #define QEMU_BUILD_BUG_ON(x) \
1566 typedef char qemu_build_bug_on[(x)?-1:1] __attribute__((unused));
1568 int main(void) {
1569 QEMU_BUILD_BUG_ON(sizeof(size_t) != GLIB_SIZEOF_SIZE_T);
1570 return 0;
1574 if ! compile_prog "$glib_cflags" "$glib_libs" ; then
1575 error_exit "sizeof(size_t) doesn't match GLIB_SIZEOF_SIZE_T."\
1576 "You probably need to set PKG_CONFIG_LIBDIR"\
1577 "to point to the right pkg-config files for your"\
1578 "build target"
1581 # Silence clang warnings triggered by glib < 2.57.2
1582 cat > $TMPC << EOF
1583 #include <glib.h>
1584 typedef struct Foo {
1585 int i;
1586 } Foo;
1587 static void foo_free(Foo *f)
1589 g_free(f);
1591 G_DEFINE_AUTOPTR_CLEANUP_FUNC(Foo, foo_free)
1592 int main(void) { return 0; }
1594 if ! compile_prog "$glib_cflags -Werror" "$glib_libs" ; then
1595 if cc_has_warning_flag "-Wno-unused-function"; then
1596 glib_cflags="$glib_cflags -Wno-unused-function"
1597 CONFIGURE_CFLAGS="$CONFIGURE_CFLAGS -Wno-unused-function"
1601 ##########################################
1602 # fdt probe
1604 case "$fdt" in
1605 auto | enabled | internal)
1606 # Simpler to always update submodule, even if not needed.
1607 git_submodules="${git_submodules} dtc"
1609 esac
1611 ##########################################
1612 # check and set a backend for coroutine
1614 # We prefer ucontext, but it's not always possible. The fallback
1615 # is sigcontext. On Windows the only valid backend is the Windows
1616 # specific one.
1618 ucontext_works=no
1619 if test "$darwin" != "yes"; then
1620 cat > $TMPC << EOF
1621 #include <ucontext.h>
1622 #ifdef __stub_makecontext
1623 #error Ignoring glibc stub makecontext which will always fail
1624 #endif
1625 int main(void) { makecontext(0, 0, 0); return 0; }
1627 if compile_prog "" "" ; then
1628 ucontext_works=yes
1632 if test "$coroutine" = ""; then
1633 if test "$mingw32" = "yes"; then
1634 coroutine=win32
1635 elif test "$ucontext_works" = "yes"; then
1636 coroutine=ucontext
1637 else
1638 coroutine=sigaltstack
1640 else
1641 case $coroutine in
1642 windows)
1643 if test "$mingw32" != "yes"; then
1644 error_exit "'windows' coroutine backend only valid for Windows"
1646 # Unfortunately the user visible backend name doesn't match the
1647 # coroutine-*.c filename for this case, so we have to adjust it here.
1648 coroutine=win32
1650 ucontext)
1651 if test "$ucontext_works" != "yes"; then
1652 error_exit "'ucontext' backend requested but makecontext not available"
1655 sigaltstack)
1656 if test "$mingw32" = "yes"; then
1657 error_exit "only the 'windows' coroutine backend is valid for Windows"
1661 error_exit "unknown coroutine backend $coroutine"
1663 esac
1666 ##################################################
1667 # SafeStack
1670 if test "$safe_stack" = "yes"; then
1671 cat > $TMPC << EOF
1672 int main(void)
1674 #if ! __has_feature(safe_stack)
1675 #error SafeStack Disabled
1676 #endif
1677 return 0;
1680 flag="-fsanitize=safe-stack"
1681 # Check that safe-stack is supported and enabled.
1682 if compile_prog "-Werror $flag" "$flag"; then
1683 # Flag needed both at compilation and at linking
1684 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1685 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1686 else
1687 error_exit "SafeStack not supported by your compiler"
1689 if test "$coroutine" != "ucontext"; then
1690 error_exit "SafeStack is only supported by the coroutine backend ucontext"
1692 else
1693 cat > $TMPC << EOF
1694 int main(void)
1696 #if defined(__has_feature)
1697 #if __has_feature(safe_stack)
1698 #error SafeStack Enabled
1699 #endif
1700 #endif
1701 return 0;
1704 if test "$safe_stack" = "no"; then
1705 # Make sure that safe-stack is disabled
1706 if ! compile_prog "-Werror" ""; then
1707 # SafeStack was already enabled, try to explicitly remove the feature
1708 flag="-fno-sanitize=safe-stack"
1709 if ! compile_prog "-Werror $flag" "$flag"; then
1710 error_exit "Configure cannot disable SafeStack"
1712 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1713 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1715 else # "$safe_stack" = ""
1716 # Set safe_stack to yes or no based on pre-existing flags
1717 if compile_prog "-Werror" ""; then
1718 safe_stack="no"
1719 else
1720 safe_stack="yes"
1721 if test "$coroutine" != "ucontext"; then
1722 error_exit "SafeStack is only supported by the coroutine backend ucontext"
1728 ########################################
1729 # check if ccache is interfering with
1730 # semantic analysis of macros
1732 unset CCACHE_CPP2
1733 ccache_cpp2=no
1734 cat > $TMPC << EOF
1735 static const int Z = 1;
1736 #define fn() ({ Z; })
1737 #define TAUT(X) ((X) == Z)
1738 #define PAREN(X, Y) (X == Y)
1739 #define ID(X) (X)
1740 int main(void)
1742 int x = 0, y = 0;
1743 x = ID(x);
1744 x = fn();
1745 fn();
1746 if (PAREN(x, y)) return 0;
1747 if (TAUT(Z)) return 0;
1748 return 0;
1752 if ! compile_object "-Werror"; then
1753 ccache_cpp2=yes
1756 #################################################
1757 # clang does not support glibc + FORTIFY_SOURCE.
1759 if test "$fortify_source" != "no"; then
1760 if echo | $cc -dM -E - | grep __clang__ > /dev/null 2>&1 ; then
1761 fortify_source="no";
1762 elif test -n "$cxx" && has $cxx &&
1763 echo | $cxx -dM -E - | grep __clang__ >/dev/null 2>&1 ; then
1764 fortify_source="no";
1765 else
1766 fortify_source="yes"
1770 ##########################################
1771 # checks for sanitizers
1773 have_asan=no
1774 have_ubsan=no
1775 have_asan_iface_h=no
1776 have_asan_iface_fiber=no
1778 if test "$sanitizers" = "yes" ; then
1779 write_c_skeleton
1780 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=address" ""; then
1781 have_asan=yes
1784 # we could use a simple skeleton for flags checks, but this also
1785 # detect the static linking issue of ubsan, see also:
1786 # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=84285
1787 cat > $TMPC << EOF
1788 int main(int argc, char **argv)
1790 return argc + 1;
1793 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=undefined" ""; then
1794 have_ubsan=yes
1797 if check_include "sanitizer/asan_interface.h" ; then
1798 have_asan_iface_h=yes
1801 cat > $TMPC << EOF
1802 #include <sanitizer/asan_interface.h>
1803 int main(void) {
1804 __sanitizer_start_switch_fiber(0, 0, 0);
1805 return 0;
1808 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=address" "" ; then
1809 have_asan_iface_fiber=yes
1813 # Thread sanitizer is, for now, much noisier than the other sanitizers;
1814 # keep it separate until that is not the case.
1815 if test "$tsan" = "yes" && test "$sanitizers" = "yes"; then
1816 error_exit "TSAN is not supported with other sanitiziers."
1818 have_tsan=no
1819 have_tsan_iface_fiber=no
1820 if test "$tsan" = "yes" ; then
1821 write_c_skeleton
1822 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=thread" "" ; then
1823 have_tsan=yes
1825 cat > $TMPC << EOF
1826 #include <sanitizer/tsan_interface.h>
1827 int main(void) {
1828 __tsan_create_fiber(0);
1829 return 0;
1832 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=thread" "" ; then
1833 have_tsan_iface_fiber=yes
1837 ##########################################
1838 # functions to probe cross compilers
1840 container="no"
1841 runc=""
1842 if test $use_containers = "yes" && (has "docker" || has "podman"); then
1843 case $($python "$source_path"/tests/docker/docker.py probe) in
1844 *docker) container=docker ;;
1845 podman) container=podman ;;
1846 no) container=no ;;
1847 esac
1848 if test "$container" != "no"; then
1849 docker_py="$python $source_path/tests/docker/docker.py --engine $container"
1850 runc=$($python "$source_path"/tests/docker/docker.py probe)
1854 # cross compilers defaults, can be overridden with --cross-cc-ARCH
1855 : ${cross_prefix_aarch64="aarch64-linux-gnu-"}
1856 : ${cross_prefix_aarch64_be="$cross_prefix_aarch64"}
1857 : ${cross_prefix_alpha="alpha-linux-gnu-"}
1858 : ${cross_prefix_arm="arm-linux-gnueabihf-"}
1859 : ${cross_prefix_armeb="$cross_prefix_arm"}
1860 : ${cross_prefix_hexagon="hexagon-unknown-linux-musl-"}
1861 : ${cross_prefix_loongarch64="loongarch64-unknown-linux-gnu-"}
1862 : ${cross_prefix_hppa="hppa-linux-gnu-"}
1863 : ${cross_prefix_i386="i686-linux-gnu-"}
1864 : ${cross_prefix_m68k="m68k-linux-gnu-"}
1865 : ${cross_prefix_microblaze="microblaze-linux-musl-"}
1866 : ${cross_prefix_mips64el="mips64el-linux-gnuabi64-"}
1867 : ${cross_prefix_mips64="mips64-linux-gnuabi64-"}
1868 : ${cross_prefix_mipsel="mipsel-linux-gnu-"}
1869 : ${cross_prefix_mips="mips-linux-gnu-"}
1870 : ${cross_prefix_nios2="nios2-linux-gnu-"}
1871 : ${cross_prefix_ppc="powerpc-linux-gnu-"}
1872 : ${cross_prefix_ppc64="powerpc64-linux-gnu-"}
1873 : ${cross_prefix_ppc64le="$cross_prefix_ppc64"}
1874 : ${cross_prefix_riscv64="riscv64-linux-gnu-"}
1875 : ${cross_prefix_s390x="s390x-linux-gnu-"}
1876 : ${cross_prefix_sh4="sh4-linux-gnu-"}
1877 : ${cross_prefix_sparc64="sparc64-linux-gnu-"}
1878 : ${cross_prefix_sparc="$cross_prefix_sparc64"}
1879 : ${cross_prefix_x86_64="x86_64-linux-gnu-"}
1881 : ${cross_cc_aarch64_be="$cross_cc_aarch64"}
1882 : ${cross_cc_cflags_aarch64_be="-mbig-endian"}
1883 : ${cross_cc_armeb="$cross_cc_arm"}
1884 : ${cross_cc_cflags_armeb="-mbig-endian"}
1885 : ${cross_cc_hexagon="hexagon-unknown-linux-musl-clang"}
1886 : ${cross_cc_cflags_hexagon="-mv67 -O2 -static"}
1887 : ${cross_cc_cflags_i386="-m32"}
1888 : ${cross_cc_cflags_ppc="-m32 -mbig-endian"}
1889 : ${cross_cc_cflags_ppc64="-m64 -mbig-endian"}
1890 : ${cross_cc_ppc64le="$cross_cc_ppc64"}
1891 : ${cross_cc_cflags_ppc64le="-m64 -mlittle-endian"}
1892 : ${cross_cc_cflags_sparc64="-m64 -mcpu=ultrasparc"}
1893 : ${cross_cc_sparc="$cross_cc_sparc64"}
1894 : ${cross_cc_cflags_sparc="-m32 -mcpu=supersparc"}
1895 : ${cross_cc_cflags_x86_64="-m64"}
1897 compute_target_variable() {
1898 eval "$2="
1899 if eval test -n "\"\${cross_prefix_$1}\""; then
1900 if eval has "\"\${cross_prefix_$1}\$3\""; then
1901 eval "$2=\"\${cross_prefix_$1}\$3\""
1906 have_target() {
1907 for i; do
1908 case " $target_list " in
1909 *" $i "*) return 0;;
1910 *) ;;
1911 esac
1912 done
1913 return 1
1916 # probe_target_compiler TARGET
1918 # Look for a compiler for the given target, either native or cross.
1919 # Set variables target_* if a compiler is found, and container_cross_*
1920 # if a Docker-based cross-compiler image is known for the target.
1921 # Set got_cross_cc to yes/no depending on whether a non-container-based
1922 # compiler was found.
1924 # If TARGET is a user-mode emulation target, also set build_static to
1925 # "y" if static linking is possible.
1927 probe_target_compiler() {
1928 # reset all output variables
1929 got_cross_cc=no
1930 container_image=
1931 container_hosts=
1932 container_cross_cc=
1933 container_cross_ar=
1934 container_cross_as=
1935 container_cross_ld=
1936 container_cross_nm=
1937 container_cross_objcopy=
1938 container_cross_ranlib=
1939 container_cross_strip=
1941 # We shall skip configuring the target compiler if the user didn't
1942 # bother enabling an appropriate guest. This avoids building
1943 # extraneous firmware images and tests.
1944 if test "${target_list#*$1}" = "$1"; then
1945 return 1
1948 target_arch=${1%%-*}
1949 case $target_arch in
1950 aarch64) container_hosts="x86_64 aarch64" ;;
1951 alpha) container_hosts=x86_64 ;;
1952 arm) container_hosts="x86_64 aarch64" ;;
1953 cris) container_hosts=x86_64 ;;
1954 hexagon) container_hosts=x86_64 ;;
1955 hppa) container_hosts=x86_64 ;;
1956 i386) container_hosts=x86_64 ;;
1957 loongarch64) container_hosts=x86_64 ;;
1958 m68k) container_hosts=x86_64 ;;
1959 microblaze) container_hosts=x86_64 ;;
1960 mips64el) container_hosts=x86_64 ;;
1961 mips64) container_hosts=x86_64 ;;
1962 mipsel) container_hosts=x86_64 ;;
1963 mips) container_hosts=x86_64 ;;
1964 nios2) container_hosts=x86_64 ;;
1965 ppc) container_hosts=x86_64 ;;
1966 ppc64|ppc64le) container_hosts=x86_64 ;;
1967 riscv64) container_hosts=x86_64 ;;
1968 s390x) container_hosts=x86_64 ;;
1969 sh4) container_hosts=x86_64 ;;
1970 sparc64) container_hosts=x86_64 ;;
1971 tricore) container_hosts=x86_64 ;;
1972 x86_64) container_hosts="aarch64 ppc64el x86_64" ;;
1973 xtensa*) container_hosts=x86_64 ;;
1974 esac
1976 for host in $container_hosts; do
1977 test "$container" != no || continue
1978 test "$host" = "$cpu" || continue
1979 case $target_arch in
1980 aarch64)
1981 # We don't have any bigendian build tools so we only use this for AArch64
1982 container_image=debian-arm64-cross
1983 container_cross_prefix=aarch64-linux-gnu-
1984 container_cross_cc=${container_cross_prefix}gcc-10
1986 alpha)
1987 container_image=debian-alpha-cross
1988 container_cross_prefix=alpha-linux-gnu-
1990 arm)
1991 # We don't have any bigendian build tools so we only use this for ARM
1992 container_image=debian-armhf-cross
1993 container_cross_prefix=arm-linux-gnueabihf-
1995 cris)
1996 container_image=fedora-cris-cross
1997 container_cross_prefix=cris-linux-gnu-
1999 hexagon)
2000 container_image=debian-hexagon-cross
2001 container_cross_prefix=hexagon-unknown-linux-musl-
2002 container_cross_cc=${container_cross_prefix}clang
2004 hppa)
2005 container_image=debian-hppa-cross
2006 container_cross_prefix=hppa-linux-gnu-
2008 i386)
2009 container_image=fedora-i386-cross
2010 container_cross_prefix=
2012 loongarch64)
2013 container_image=debian-loongarch-cross
2014 container_cross_prefix=loongarch64-unknown-linux-gnu-
2016 m68k)
2017 container_image=debian-m68k-cross
2018 container_cross_prefix=m68k-linux-gnu-
2020 microblaze)
2021 container_image=debian-microblaze-cross
2022 container_cross_prefix=microblaze-linux-musl-
2024 mips64el)
2025 container_image=debian-mips64el-cross
2026 container_cross_prefix=mips64el-linux-gnuabi64-
2028 mips64)
2029 container_image=debian-mips64-cross
2030 container_cross_prefix=mips64-linux-gnuabi64-
2032 mipsel)
2033 container_image=debian-mipsel-cross
2034 container_cross_prefix=mipsel-linux-gnu-
2036 mips)
2037 container_image=debian-mips-cross
2038 container_cross_prefix=mips-linux-gnu-
2040 nios2)
2041 container_image=debian-nios2-cross
2042 container_cross_prefix=nios2-linux-gnu-
2044 ppc)
2045 container_image=debian-powerpc-test-cross
2046 container_cross_prefix=powerpc-linux-gnu-
2047 container_cross_cc=${container_cross_prefix}gcc-10
2049 ppc64|ppc64le)
2050 container_image=debian-powerpc-test-cross
2051 container_cross_prefix=powerpc${target_arch#ppc}-linux-gnu-
2052 container_cross_cc=${container_cross_prefix}gcc-10
2054 riscv64)
2055 container_image=debian-riscv64-test-cross
2056 container_cross_prefix=riscv64-linux-gnu-
2058 s390x)
2059 container_image=debian-s390x-cross
2060 container_cross_prefix=s390x-linux-gnu-
2062 sh4)
2063 container_image=debian-sh4-cross
2064 container_cross_prefix=sh4-linux-gnu-
2066 sparc64)
2067 container_image=debian-sparc64-cross
2068 container_cross_prefix=sparc64-linux-gnu-
2070 tricore)
2071 container_image=debian-tricore-cross
2072 container_cross_prefix=tricore-
2073 container_cross_as=tricore-as
2074 container_cross_ld=tricore-ld
2075 break
2077 x86_64)
2078 container_image=debian-amd64-cross
2079 container_cross_prefix=x86_64-linux-gnu-
2081 xtensa*)
2082 container_hosts=x86_64
2083 container_image=debian-xtensa-cross
2085 # default to the dc232b cpu
2086 container_cross_prefix=/opt/2020.07/xtensa-dc232b-elf/bin/xtensa-dc232b-elf-
2088 esac
2089 : ${container_cross_cc:=${container_cross_prefix}gcc}
2090 : ${container_cross_ar:=${container_cross_prefix}ar}
2091 : ${container_cross_as:=${container_cross_prefix}as}
2092 : ${container_cross_ld:=${container_cross_prefix}ld}
2093 : ${container_cross_nm:=${container_cross_prefix}nm}
2094 : ${container_cross_objcopy:=${container_cross_prefix}objcopy}
2095 : ${container_cross_ranlib:=${container_cross_prefix}ranlib}
2096 : ${container_cross_strip:=${container_cross_prefix}strip}
2097 done
2099 try=cross
2100 case "$target_arch:$cpu" in
2101 aarch64_be:aarch64 | \
2102 armeb:arm | \
2103 i386:x86_64 | \
2104 mips*:mips64 | \
2105 ppc*:ppc64 | \
2106 sparc:sparc64 | \
2107 "$cpu:$cpu")
2108 try='native cross' ;;
2109 esac
2110 eval "target_cflags=\${cross_cc_cflags_$target_arch}"
2111 for thistry in $try; do
2112 case $thistry in
2113 native)
2114 target_cc=$cc
2115 target_ccas=$ccas
2116 target_ar=$ar
2117 target_as=$as
2118 target_ld=$ld
2119 target_nm=$nm
2120 target_objcopy=$objcopy
2121 target_ranlib=$ranlib
2122 target_strip=$strip
2124 cross)
2125 target_cc=
2126 if eval test -n "\"\${cross_cc_$target_arch}\""; then
2127 if eval has "\"\${cross_cc_$target_arch}\""; then
2128 eval "target_cc=\"\${cross_cc_$target_arch}\""
2130 else
2131 compute_target_variable $target_arch target_cc gcc
2133 target_ccas=$target_cc
2134 compute_target_variable $target_arch target_ar ar
2135 compute_target_variable $target_arch target_as as
2136 compute_target_variable $target_arch target_ld ld
2137 compute_target_variable $target_arch target_nm nm
2138 compute_target_variable $target_arch target_objcopy objcopy
2139 compute_target_variable $target_arch target_ranlib ranlib
2140 compute_target_variable $target_arch target_strip strip
2142 esac
2144 if test -n "$target_cc"; then
2145 case $target_arch in
2146 i386|x86_64)
2147 if $target_cc --version | grep -qi "clang"; then
2148 continue
2151 esac
2152 elif test -n "$target_as" && test -n "$target_ld"; then
2153 # Special handling for assembler only targets
2154 case $target in
2155 tricore-softmmu)
2156 build_static=
2157 got_cross_cc=yes
2158 break
2161 continue
2163 esac
2164 else
2165 continue
2168 write_c_skeleton
2169 case $1 in
2170 *-softmmu)
2171 if do_compiler "$target_cc" $target_cflags -o $TMPO -c $TMPC &&
2172 do_compiler "$target_cc" $target_cflags -r -nostdlib -o "${TMPDIR1}/${TMPB}2.o" "$TMPO" -lgcc; then
2173 got_cross_cc=yes
2174 break
2178 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC -static ; then
2179 build_static=y
2180 got_cross_cc=yes
2181 break
2183 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC ; then
2184 build_static=
2185 got_cross_cc=yes
2186 break
2189 esac
2190 done
2191 if test $got_cross_cc != yes; then
2192 build_static=
2193 target_cc=
2194 target_ccas=
2195 target_ar=
2196 target_as=
2197 target_ld=
2198 target_nm=
2199 target_objcopy=
2200 target_ranlib=
2201 target_strip=
2203 test -n "$target_cc"
2206 write_target_makefile() {
2207 echo "EXTRA_CFLAGS=$target_cflags"
2208 if test -z "$target_cc" && test -z "$target_as"; then
2209 test -z "$container_image" && error_exit "Internal error: could not find cross compiler for $1?"
2210 echo "$1: docker-image-$container_image" >> Makefile.prereqs
2211 if test -n "$container_cross_cc"; then
2212 echo "CC=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
2213 echo "CCAS=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
2215 echo "AR=$docker_py cc --cc $container_cross_ar -i qemu/$container_image -s $source_path --"
2216 echo "AS=$docker_py cc --cc $container_cross_as -i qemu/$container_image -s $source_path --"
2217 echo "LD=$docker_py cc --cc $container_cross_ld -i qemu/$container_image -s $source_path --"
2218 echo "NM=$docker_py cc --cc $container_cross_nm -i qemu/$container_image -s $source_path --"
2219 echo "OBJCOPY=$docker_py cc --cc $container_cross_objcopy -i qemu/$container_image -s $source_path --"
2220 echo "RANLIB=$docker_py cc --cc $container_cross_ranlib -i qemu/$container_image -s $source_path --"
2221 echo "STRIP=$docker_py cc --cc $container_cross_strip -i qemu/$container_image -s $source_path --"
2222 else
2223 if test -n "$target_cc"; then
2224 echo "CC=$target_cc"
2225 echo "CCAS=$target_ccas"
2227 if test -n "$target_ar"; then
2228 echo "AR=$target_ar"
2230 if test -n "$target_as"; then
2231 echo "AS=$target_as"
2233 if test -n "$target_ld"; then
2234 echo "LD=$target_ld"
2236 if test -n "$target_nm"; then
2237 echo "NM=$target_nm"
2239 if test -n "$target_objcopy"; then
2240 echo "OBJCOPY=$target_objcopy"
2242 if test -n "$target_ranlib"; then
2243 echo "RANLIB=$target_ranlib"
2245 if test -n "$target_strip"; then
2246 echo "STRIP=$target_strip"
2251 ##########################################
2252 # check for vfio_user_server
2254 case "$vfio_user_server" in
2255 enabled )
2256 if test "$git_submodules_action" != "ignore"; then
2257 git_submodules="${git_submodules} subprojects/libvfio-user"
2260 esac
2262 ##########################################
2263 # End of CC checks
2264 # After here, no more $cc or $ld runs
2266 write_c_skeleton
2268 if test "$fortify_source" = "yes" ; then
2269 QEMU_CFLAGS="-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 $QEMU_CFLAGS"
2272 if test "$have_asan" = "yes"; then
2273 QEMU_CFLAGS="-fsanitize=address $QEMU_CFLAGS"
2274 QEMU_LDFLAGS="-fsanitize=address $QEMU_LDFLAGS"
2275 if test "$have_asan_iface_h" = "no" ; then
2276 echo "ASAN build enabled, but ASAN header missing." \
2277 "Without code annotation, the report may be inferior."
2278 elif test "$have_asan_iface_fiber" = "no" ; then
2279 echo "ASAN build enabled, but ASAN header is too old." \
2280 "Without code annotation, the report may be inferior."
2283 if test "$have_tsan" = "yes" ; then
2284 if test "$have_tsan_iface_fiber" = "yes" ; then
2285 QEMU_CFLAGS="-fsanitize=thread $QEMU_CFLAGS"
2286 QEMU_LDFLAGS="-fsanitize=thread $QEMU_LDFLAGS"
2287 else
2288 error_exit "Cannot enable TSAN due to missing fiber annotation interface."
2290 elif test "$tsan" = "yes" ; then
2291 error_exit "Cannot enable TSAN due to missing sanitize thread interface."
2293 if test "$have_ubsan" = "yes"; then
2294 QEMU_CFLAGS="-fsanitize=undefined $QEMU_CFLAGS"
2295 QEMU_LDFLAGS="-fsanitize=undefined $QEMU_LDFLAGS"
2298 #######################################
2299 # cross-compiled firmware targets
2301 # Set up build tree symlinks that point back into the source tree
2302 # (these can be both files and directories).
2303 # Caution: avoid adding files or directories here using wildcards. This
2304 # will result in problems later if a new file matching the wildcard is
2305 # added to the source tree -- nothing will cause configure to be rerun
2306 # so the build tree will be missing the link back to the new file, and
2307 # tests might fail. Prefer to keep the relevant files in their own
2308 # directory and symlink the directory instead.
2309 LINKS="Makefile"
2310 LINKS="$LINKS docs/config"
2311 LINKS="$LINKS pc-bios/optionrom/Makefile"
2312 LINKS="$LINKS pc-bios/s390-ccw/Makefile"
2313 LINKS="$LINKS pc-bios/vof/Makefile"
2314 LINKS="$LINKS .gdbinit scripts" # scripts needed by relative path in .gdbinit
2315 LINKS="$LINKS tests/avocado tests/data"
2316 LINKS="$LINKS tests/qemu-iotests/check"
2317 LINKS="$LINKS python"
2318 LINKS="$LINKS contrib/plugins/Makefile "
2319 for f in $LINKS ; do
2320 if [ -e "$source_path/$f" ]; then
2321 mkdir -p "$(dirname ./"$f")"
2322 symlink "$source_path/$f" "$f"
2324 done
2326 echo "# Automatically generated by configure - do not modify" > Makefile.prereqs
2328 # Mac OS X ships with a broken assembler
2329 roms=
2330 if have_target i386-softmmu x86_64-softmmu && \
2331 test "$targetos" != "darwin" && test "$targetos" != "sunos" && \
2332 test "$targetos" != "haiku" && \
2333 probe_target_compiler i386-softmmu; then
2334 roms="pc-bios/optionrom"
2335 config_mak=pc-bios/optionrom/config.mak
2336 echo "# Automatically generated by configure - do not modify" > $config_mak
2337 echo "TOPSRC_DIR=$source_path" >> $config_mak
2338 write_target_makefile >> $config_mak
2341 if have_target ppc-softmmu ppc64-softmmu && \
2342 probe_target_compiler ppc-softmmu; then
2343 roms="$roms pc-bios/vof"
2344 config_mak=pc-bios/vof/config.mak
2345 echo "# Automatically generated by configure - do not modify" > $config_mak
2346 echo "SRC_DIR=$source_path/pc-bios/vof" >> $config_mak
2347 write_target_makefile >> $config_mak
2350 # Only build s390-ccw bios if the compiler has -march=z900 or -march=z10
2351 # (which is the lowest architecture level that Clang supports)
2352 if have_target s390x-softmmu && probe_target_compiler s390x-softmmu; then
2353 write_c_skeleton
2354 do_compiler "$target_cc" $target_cc_cflags -march=z900 -o $TMPO -c $TMPC
2355 has_z900=$?
2356 if [ $has_z900 = 0 ] || do_compiler "$target_cc" $target_cc_cflags -march=z10 -msoft-float -Werror -o $TMPO -c $TMPC; then
2357 if [ $has_z900 != 0 ]; then
2358 echo "WARNING: Your compiler does not support the z900!"
2359 echo " The s390-ccw bios will only work with guest CPUs >= z10."
2361 roms="$roms pc-bios/s390-ccw"
2362 config_mak=pc-bios/s390-ccw/config-host.mak
2363 echo "# Automatically generated by configure - do not modify" > $config_mak
2364 echo "SRC_PATH=$source_path/pc-bios/s390-ccw" >> $config_mak
2365 write_target_makefile >> $config_mak
2366 # SLOF is required for building the s390-ccw firmware on s390x,
2367 # since it is using the libnet code from SLOF for network booting.
2368 git_submodules="${git_submodules} roms/SLOF"
2372 #######################################
2373 # generate config-host.mak
2375 if ! (GIT="$git" "$source_path/scripts/git-submodule.sh" "$git_submodules_action" "$git_submodules"); then
2376 exit 1
2379 config_host_mak="config-host.mak"
2381 echo "# Automatically generated by configure - do not modify" > $config_host_mak
2382 echo >> $config_host_mak
2384 echo all: >> $config_host_mak
2385 echo "GIT=$git" >> $config_host_mak
2386 echo "GIT_SUBMODULES=$git_submodules" >> $config_host_mak
2387 echo "GIT_SUBMODULES_ACTION=$git_submodules_action" >> $config_host_mak
2389 if test "$debug_tcg" = "yes" ; then
2390 echo "CONFIG_DEBUG_TCG=y" >> $config_host_mak
2392 if test "$mingw32" = "yes" ; then
2393 echo "CONFIG_WIN32=y" >> $config_host_mak
2394 echo "QEMU_GA_MANUFACTURER=${QEMU_GA_MANUFACTURER-QEMU}" >> $config_host_mak
2395 echo "QEMU_GA_DISTRO=${QEMU_GA_DISTRO-Linux}" >> $config_host_mak
2396 echo "QEMU_GA_VERSION=${QEMU_GA_VERSION-$(cat "$source_path"/VERSION)}" >> $config_host_mak
2397 else
2398 echo "CONFIG_POSIX=y" >> $config_host_mak
2401 if test "$linux" = "yes" ; then
2402 echo "CONFIG_LINUX=y" >> $config_host_mak
2405 if test "$darwin" = "yes" ; then
2406 echo "CONFIG_DARWIN=y" >> $config_host_mak
2409 if test "$solaris" = "yes" ; then
2410 echo "CONFIG_SOLARIS=y" >> $config_host_mak
2412 echo "SRC_PATH=$source_path" >> $config_host_mak
2413 echo "TARGET_DIRS=$target_list" >> $config_host_mak
2414 if test "$modules" = "yes"; then
2415 echo "CONFIG_MODULES=y" >> $config_host_mak
2418 # XXX: suppress that
2419 if [ "$bsd" = "yes" ] ; then
2420 echo "CONFIG_BSD=y" >> $config_host_mak
2423 echo "CONFIG_COROUTINE_BACKEND=$coroutine" >> $config_host_mak
2425 if test "$have_asan_iface_fiber" = "yes" ; then
2426 echo "CONFIG_ASAN_IFACE_FIBER=y" >> $config_host_mak
2429 if test "$have_tsan" = "yes" && test "$have_tsan_iface_fiber" = "yes" ; then
2430 echo "CONFIG_TSAN=y" >> $config_host_mak
2433 if test "$plugins" = "yes" ; then
2434 echo "CONFIG_PLUGIN=y" >> $config_host_mak
2437 if test -n "$gdb_bin"; then
2438 gdb_version=$($gdb_bin --version | head -n 1)
2439 if version_ge ${gdb_version##* } 9.1; then
2440 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
2441 gdb_arches=$("$source_path/scripts/probe-gdb-support.py" $gdb_bin)
2442 else
2443 gdb_bin=""
2447 if test "$container" != no; then
2448 echo "ENGINE=$container" >> $config_host_mak
2449 echo "RUNC=$runc" >> $config_host_mak
2451 echo "ROMS=$roms" >> $config_host_mak
2452 echo "MAKE=$make" >> $config_host_mak
2453 echo "PYTHON=$python" >> $config_host_mak
2454 echo "GENISOIMAGE=$genisoimage" >> $config_host_mak
2455 echo "MESON=$meson" >> $config_host_mak
2456 echo "NINJA=$ninja" >> $config_host_mak
2457 echo "CC=$cc" >> $config_host_mak
2458 echo "QEMU_CFLAGS=$QEMU_CFLAGS" >> $config_host_mak
2459 echo "QEMU_OBJCFLAGS=$QEMU_OBJCFLAGS" >> $config_host_mak
2460 echo "GLIB_CFLAGS=$glib_cflags" >> $config_host_mak
2461 echo "GLIB_LIBS=$glib_libs" >> $config_host_mak
2462 echo "GLIB_BINDIR=$glib_bindir" >> $config_host_mak
2463 echo "GLIB_VERSION=$($pkg_config --modversion glib-2.0)" >> $config_host_mak
2464 if test "$glib_has_gslice" = "yes" ; then
2465 echo "HAVE_GLIB_WITH_SLICE_ALLOCATOR=y" >> $config_host_mak
2467 echo "QEMU_LDFLAGS=$QEMU_LDFLAGS" >> $config_host_mak
2468 echo "EXESUF=$EXESUF" >> $config_host_mak
2470 # use included Linux headers
2471 if test "$linux" = "yes" ; then
2472 mkdir -p linux-headers
2473 case "$cpu" in
2474 i386|x86_64)
2475 linux_arch=x86
2477 ppc|ppc64)
2478 linux_arch=powerpc
2480 s390x)
2481 linux_arch=s390
2483 aarch64)
2484 linux_arch=arm64
2486 loongarch*)
2487 linux_arch=loongarch
2489 mips64)
2490 linux_arch=mips
2493 # For most CPUs the kernel architecture name and QEMU CPU name match.
2494 linux_arch="$cpu"
2496 esac
2497 # For non-KVM architectures we will not have asm headers
2498 if [ -e "$source_path/linux-headers/asm-$linux_arch" ]; then
2499 symlink "$source_path/linux-headers/asm-$linux_arch" linux-headers/asm
2503 for target in $target_list; do
2504 target_dir="$target"
2505 target_name=$(echo $target | cut -d '-' -f 1)$EXESUF
2506 mkdir -p "$target_dir"
2507 case $target in
2508 *-user) symlink "../qemu-$target_name" "$target_dir/qemu-$target_name" ;;
2509 *) symlink "../qemu-system-$target_name" "$target_dir/qemu-system-$target_name" ;;
2510 esac
2511 done
2513 if test "$default_targets" = "yes"; then
2514 echo "CONFIG_DEFAULT_TARGETS=y" >> $config_host_mak
2517 if test "$ccache_cpp2" = "yes"; then
2518 echo "export CCACHE_CPP2=y" >> $config_host_mak
2521 if test "$safe_stack" = "yes"; then
2522 echo "CONFIG_SAFESTACK=y" >> $config_host_mak
2525 # tests/tcg configuration
2526 (config_host_mak=tests/tcg/config-host.mak
2527 mkdir -p tests/tcg
2528 echo "# Automatically generated by configure - do not modify" > $config_host_mak
2529 echo "SRC_PATH=$source_path" >> $config_host_mak
2530 echo "HOST_CC=$host_cc" >> $config_host_mak
2532 # versioned checked in the main config_host.mak above
2533 if test -n "$gdb_bin"; then
2534 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
2536 if test "$plugins" = "yes" ; then
2537 echo "CONFIG_PLUGIN=y" >> $config_host_mak
2540 tcg_tests_targets=
2541 for target in $target_list; do
2542 arch=${target%%-*}
2544 case $target in
2545 xtensa*-linux-user)
2546 # the toolchain is not complete with headers, only build softmmu tests
2547 continue
2549 *-softmmu)
2550 test -f "$source_path/tests/tcg/$arch/Makefile.softmmu-target" || continue
2551 qemu="qemu-system-$arch"
2553 *-linux-user|*-bsd-user)
2554 qemu="qemu-$arch"
2556 esac
2558 if probe_target_compiler $target || test -n "$container_image"; then
2559 test -n "$container_image" && build_static=y
2560 mkdir -p "tests/tcg/$target"
2561 config_target_mak=tests/tcg/$target/config-target.mak
2562 ln -sf "$source_path/tests/tcg/Makefile.target" "tests/tcg/$target/Makefile"
2563 echo "# Automatically generated by configure - do not modify" > "$config_target_mak"
2564 echo "TARGET_NAME=$arch" >> "$config_target_mak"
2565 echo "TARGET=$target" >> "$config_target_mak"
2566 write_target_makefile "build-tcg-tests-$target" >> "$config_target_mak"
2567 echo "BUILD_STATIC=$build_static" >> "$config_target_mak"
2568 echo "QEMU=$PWD/$qemu" >> "$config_target_mak"
2570 # will GDB work with these binaries?
2571 if test "${gdb_arches#*$arch}" != "$gdb_arches"; then
2572 echo "HOST_GDB_SUPPORTS_ARCH=y" >> "$config_target_mak"
2575 echo "run-tcg-tests-$target: $qemu\$(EXESUF)" >> Makefile.prereqs
2576 tcg_tests_targets="$tcg_tests_targets $target"
2578 done
2580 if test "$tcg" = "enabled"; then
2581 echo "TCG_TESTS_TARGETS=$tcg_tests_targets" >> config-host.mak
2585 if test "$skip_meson" = no; then
2586 cross="config-meson.cross.new"
2587 meson_quote() {
2588 test $# = 0 && return
2589 echo "'$(echo $* | sed "s/ /','/g")'"
2592 echo "# Automatically generated by configure - do not modify" > $cross
2593 echo "[properties]" >> $cross
2595 # unroll any custom device configs
2596 for a in $device_archs; do
2597 eval "c=\$devices_${a}"
2598 echo "${a}-softmmu = '$c'" >> $cross
2599 done
2601 echo "[built-in options]" >> $cross
2602 echo "c_args = [$(meson_quote $CFLAGS $EXTRA_CFLAGS)]" >> $cross
2603 echo "cpp_args = [$(meson_quote $CXXFLAGS $EXTRA_CXXFLAGS)]" >> $cross
2604 test -n "$objcc" && echo "objc_args = [$(meson_quote $OBJCFLAGS $EXTRA_OBJCFLAGS)]" >> $cross
2605 echo "c_link_args = [$(meson_quote $CFLAGS $LDFLAGS $EXTRA_CFLAGS $EXTRA_LDFLAGS)]" >> $cross
2606 echo "cpp_link_args = [$(meson_quote $CXXFLAGS $LDFLAGS $EXTRA_CXXFLAGS $EXTRA_LDFLAGS)]" >> $cross
2607 echo "[binaries]" >> $cross
2608 echo "c = [$(meson_quote $cc $CPU_CFLAGS)]" >> $cross
2609 test -n "$cxx" && echo "cpp = [$(meson_quote $cxx $CPU_CFLAGS)]" >> $cross
2610 test -n "$objcc" && echo "objc = [$(meson_quote $objcc $CPU_CFLAGS)]" >> $cross
2611 echo "ar = [$(meson_quote $ar)]" >> $cross
2612 echo "nm = [$(meson_quote $nm)]" >> $cross
2613 echo "pkgconfig = [$(meson_quote $pkg_config_exe)]" >> $cross
2614 echo "ranlib = [$(meson_quote $ranlib)]" >> $cross
2615 if has $sdl2_config; then
2616 echo "sdl2-config = [$(meson_quote $sdl2_config)]" >> $cross
2618 echo "strip = [$(meson_quote $strip)]" >> $cross
2619 echo "widl = [$(meson_quote $widl)]" >> $cross
2620 echo "windres = [$(meson_quote $windres)]" >> $cross
2621 echo "windmc = [$(meson_quote $windmc)]" >> $cross
2622 if test "$cross_compile" = "yes"; then
2623 cross_arg="--cross-file config-meson.cross"
2624 echo "[host_machine]" >> $cross
2625 echo "system = '$targetos'" >> $cross
2626 case "$cpu" in
2627 i386)
2628 echo "cpu_family = 'x86'" >> $cross
2631 echo "cpu_family = '$cpu'" >> $cross
2633 esac
2634 echo "cpu = '$cpu'" >> $cross
2635 if test "$bigendian" = "yes" ; then
2636 echo "endian = 'big'" >> $cross
2637 else
2638 echo "endian = 'little'" >> $cross
2640 else
2641 cross_arg="--native-file config-meson.cross"
2643 mv $cross config-meson.cross
2645 rm -rf meson-private meson-info meson-logs
2647 # Prevent meson from automatically downloading wrapped subprojects when missing.
2648 # You can use 'meson subprojects download' before running configure.
2649 meson_option_add "--wrap-mode=nodownload"
2651 # Built-in options
2652 test "$bindir" != "bin" && meson_option_add "-Dbindir=$bindir"
2653 test "$default_feature" = no && meson_option_add -Dauto_features=disabled
2654 test "$static" = yes && meson_option_add -Dprefer_static=true
2655 test "$pie" = no && meson_option_add -Db_pie=false
2656 test "$werror" = yes && meson_option_add -Dwerror=true
2658 # QEMU options
2659 test "$cfi" != false && meson_option_add "-Dcfi=$cfi"
2660 test "$docs" != auto && meson_option_add "-Ddocs=$docs"
2661 test "$fdt" != auto && meson_option_add "-Dfdt=$fdt"
2662 test -n "${LIB_FUZZING_ENGINE+xxx}" && meson_option_add "-Dfuzzing_engine=$LIB_FUZZING_ENGINE"
2663 test "$qemu_suffix" != qemu && meson_option_add "-Dqemu_suffix=$qemu_suffix"
2664 test "$smbd" != '' && meson_option_add "-Dsmbd=$smbd"
2665 test "$tcg" != enabled && meson_option_add "-Dtcg=$tcg"
2666 test "$vfio_user_server" != auto && meson_option_add "-Dvfio_user_server=$vfio_user_server"
2667 run_meson() {
2668 NINJA=$ninja $meson setup --prefix "$prefix" "$@" $cross_arg "$PWD" "$source_path"
2670 eval run_meson $meson_options
2671 if test "$?" -ne 0 ; then
2672 error_exit "meson setup failed"
2676 # Save the configure command line for later reuse.
2677 cat <<EOD >config.status
2678 #!/bin/sh
2679 # Generated by configure.
2680 # Run this file to recreate the current configuration.
2681 # Compiler output produced by configure, useful for debugging
2682 # configure, is in config.log if it exists.
2685 preserve_env() {
2686 envname=$1
2688 eval envval=\$$envname
2690 if test -n "$envval"
2691 then
2692 echo "$envname='$envval'" >> config.status
2693 echo "export $envname" >> config.status
2694 else
2695 echo "unset $envname" >> config.status
2699 # Preserve various env variables that influence what
2700 # features/build target configure will detect
2701 preserve_env AR
2702 preserve_env AS
2703 preserve_env CC
2704 preserve_env CFLAGS
2705 preserve_env CXX
2706 preserve_env CXXFLAGS
2707 preserve_env LD
2708 preserve_env LDFLAGS
2709 preserve_env LD_LIBRARY_PATH
2710 preserve_env MAKE
2711 preserve_env NM
2712 preserve_env OBJCFLAGS
2713 preserve_env OBJCOPY
2714 preserve_env PATH
2715 preserve_env PKG_CONFIG
2716 preserve_env PKG_CONFIG_LIBDIR
2717 preserve_env PKG_CONFIG_PATH
2718 preserve_env PYTHON
2719 preserve_env QEMU_GA_MANUFACTURER
2720 preserve_env QEMU_GA_DISTRO
2721 preserve_env QEMU_GA_VERSION
2722 preserve_env SDL2_CONFIG
2723 preserve_env SMBD
2724 preserve_env STRIP
2725 preserve_env WIDL
2726 preserve_env WINDRES
2727 preserve_env WINDMC
2729 printf "exec" >>config.status
2730 for i in "$0" "$@"; do
2731 test "$i" = --skip-meson || printf " %s" "$(quote_sh "$i")" >>config.status
2732 done
2733 echo ' "$@"' >>config.status
2734 chmod +x config.status
2736 rm -r "$TMPDIR1"